<style scoped>
	ins-order-plan-main .title {
		font-size: 20px;
		color: #3A7BFA
	}

	.search {
		background-color: #fff;
		height: 80px;
		display: flex;
		align-items: center;
	}

	.search_thing {
		display: flex;
		align-items: center;
		height: 50px;
	}

	.search_label {
		width: 120px;
		font-size: 14px;
		text-align: right;
	}

	.search_input {
		width: calc(100% - 120px);
	}

	.ins-order-plan-main .search {
		width: 100%;
		margin-bottom: 10px;
		height: 80px;
		background-color: #fff;
		border-radius: 3px;
	}

	.search .form-inline {
		height: 50px;
		padding-top: 20px;
		padding-left: 50px;
	}

	.ins-order-plan-main .center {
		width: calc(100% - 40px);
		height: calc(100% - 60px - 80px - 40px);
		background-color: #fff;
		border-radius: 3px;
		padding: 20px;
	}

	.ins-order-plan-main .center .value-table {
		width: 100%;
		height: calc(100% - 68px);
	}

	.tab {
		list-style-type: none;
		display: flex;
	}

	.tab li {
		line-height: 24px;
		padding: 6px 14px;
		font-size: 14px;
		color: #333333;
		border: 1px solid #EEEEEE;
		cursor: pointer;
	}

	.tab li:nth-child(1) {
		border-radius: 8px 0 0 8px;
	}

	.tab li:nth-child(3) {
		border-radius: 0 8px 8px 0;
	}

	.tab li.active {
		border-color: #3A7BFA;
		color: #3A7BFA;
	}

	.center .center-options .center-title {
		width: 100%;
		display: flex;
		align-items: center;
		justify-content: right;
	}

	.center .center-options .center-title span:last-child {
		color: #3A7BFA;
		font-size: 23px;
		font-weight: 400;
	}

	.view-self-checkbox {
		margin-left: 50px;
	}
</style>
<style>
	.ins-order-plan-main .el-form-item__label{
		color: #000;
	}
</style>
<template>
	<div class="ins-order-plan-main">
		<div v-show="activeFace == 0&&state==0" style="height: 100%;">
			<p style="font-size: 16px;padding:19.5px 0px">检验任务</p>
			<div class="search">
				<div class="search_thing">
					<div class="search_label">委托编号：</div>
					<div class="search_input"><el-input size="small" placeholder="请输入" clearable
							v-model="componentData.entity.entrustCode" @keyup.enter.native="refreshTable()"></el-input></div>
				</div>
				<div class="search_thing">
					<div class="search_label">检验状态：</div>
					<div class="search_input">
						<el-select size="small" v-model="componentData.entity.insState" style="width: 100%;" @change="refreshTable()">
							<el-option v-for="(a, i) in insStateList" :key="i" :label="a.label" :value="a.value"></el-option>
						</el-select>
					</div>
				</div>
				<div class="search_thing" style="padding-left: 30px;">
					<el-button size="small" @click="refresh()">重 置</el-button>
					<el-button size="small" type="primary" @click="refreshTable()">查 询</el-button>
				</div>
			</div>
			<div class="center">
				<div class="center-options">
					<el-row>
						<el-col :span="21">
							<div style="display: flex;align-items: center;margin-bottom: 10px;">
								<ul class="tab">
									<li v-for="(m,i) in tabList" :key="i" :class="{active:i==tabIndex}" @click="handleTab(m,i)">{{m.label}}
									</li>
								</ul>
								<div>
									<el-checkbox @change="changeCheckBox" class="view-self-checkbox"
										v-model="alone"><span>我的任务</span></el-checkbox>
								</div>
							</div>
						</el-col>
						<el-col :span="3">
							<div class="center-title">
								<span>总计任务数量:</span>
								<span v-if="$refs.insOrderPlan != undefined">{{$refs.insOrderPlan.total}}</span>
							</div>
						</el-col>
					</el-row>
				</div>
				<ValueTable :tableRowClassName="changeRowClass" class="value-table" ref="insOrderPlan"
					:url="$api.insOrderPlan.selectInsOrderPlanList" :upUrl="$api.user.updateUser" :componentData="componentData" @handleInspection="handleInspection"
					:key="upIndex"/>
			</div>
		</div>
		<el-dialog title="提示" :visible.sync="claimVisible" width="400px">
			是否认领委托编号<span style="color:#33C130">{{sampleUserForm.entrustCode}}</span>的任务
			<span slot="footer" class="dialog-footer">
				<el-button @click="claimVisible = false">取 消</el-button>
				<el-button type="primary" @click="confirmClaim">确 定</el-button>
			</span>
		</el-dialog>
		<div style="width: 100%;height: 100%;" v-if="activeFace >0">
			<Add :active="activeFace" :currentId="currentId"/>
		</div>
    <Inspection v-if="state==1" @goback="state=0" :orderId="orderId"/>
	</div>
</template>

<script>
	import ValueTable from '../tool/value-table.vue'
  import Inspection from '../do/b1-inspect-order-plan/Inspection.vue'
	import {
		getYearAndMonthAndDays
	} from '../../util/date'
	import Add from '../do/b1-ins-order/add.vue'
import { number } from 'echarts'
	export default {
		components: {
			ValueTable,
      Inspection,
			Add
		},
		data() {
			return {
				alone: false,
				sampleUserForm: {
					entrustCode: null,
					insSampleId: null,
					userId: null
				},
				claimVisible: false,
				tabList: [],
				active: 1,
				tabIndex: 0,
				componentData: {
					entity: {
						sonLaboratory: null,
						insState: null,
						userId: null
					},
					isIndex: true,
					showSelect: false,
					select: false,
					sort: false,
					init: false,
					do: [{
							id: '',
							font: '检验',
							type: 'text',
							method: 'handleInspection'
						}, {
							id: '',
							font: '交接',
							type: 'text',
							method: ''
						},
						{
							id: '',
							font: '复核',
							type: 'text',
							method: ''
						}, {
							id: '',
							font: '认领',
							type: 'text',
							method: 'claimFun',
							disabFun: (row, index) => {
								return row.userId != null
							}
						}
					],
					linkEvent: {
						entrustCode: {
							method: 'selectAllByOne'
						}
					},
					tagField: {
						type: {
							select: []
						},
						insState: {
							select: []
						},
						insResult: {
							select: [{
								value: 0,
								label: '不合格',
								type: 'danger'
							},{
								value: 1,
								label: '合格',
								type: 'success'
							},{
								value: '',
								label: '未出结果',
								type: 'info'
							}]
						}
					},
					selectField: {},
					requiredAdd: [],
					requiredUp: []
				},
				upIndex: 0,
				planTotal: 0,
				insStateList: [],
        state:0,//0:台账页，1：检验页面，默认为0
				activeFace: 0, //1：下单，2：查看，3：审核
				currentId: null,
				entityCopy: {},
				orderId: 0
			}
		},
		created() {
			this.getLaboratoryDicts()
			this.getTypeDicts()
			this.getInsStateDicts()
		},
		mounted() {
			this.entityCopy = this.HaveJson(this.componentData.entity)
		},
		methods: {
			changeCheckBox(val) {
				this.componentData.entity.userId = val?0:null
				this.refreshTable()
			},
			refresh() {
				this.componentData.entity = this.HaveJson(this.entityCopy)
				if(this.tabList.length>0){
					this.tabIndex = 0
					this.componentData.entity.sonLaboratory = this.tabList[0].value
				}
				this.refreshTable()
			},
			claimFun(row) {
				if (row) {
					this.sampleUserForm = {
						entrustCode: row.entrustCode,
						insSampleId: row.id
					}
					this.claimVisible = true
				}
			},
			confirmClaim() {
				this.$axios.post(this.$api.insOrderPlan.claimInsOrderPlan, this.sampleUserForm, {
					headers: {
						'Content-Type': 'application/json'
					}
				}).then(res => {
					if (res.code === 200 && res.data) {
						this.$message.success("认领成功")
						this.claimVisible = false
						this.refreshTable()
					}
				}).catch(error => {
					console.error(error)
				})
			},
			refreshTable() {
				this.$refs.insOrderPlan.selectList()
			},
			changeRowClass({
				row,
				rowIndex
			}) {
				let currentTime = getYearAndMonthAndDays()
				if (currentTime === row.appointed) {
					return 'highlight-warning-row-border'
				} else if (currentTime > row.appointed) {
					return 'highlight-danger-row-border'
				}
				return ''
			},
			onReset() {
				this.searchForm = {
					sampleName: null,
					state: null,
				}
				this.componentData.entity.insState = null
				this.componentData.entity.sampleName = null
				this.refreshTable()
			},
			onSubmit() {
				this.componentData.entity.insState = this.searchForm.state
				this.componentData.entity.sampleName = this.searchForm.sampleName
				this.$nextTick(() => {
					this.refreshTable()
				})
			},
			handleTab(m, i) {
				this.tabIndex = i;
				this.componentData.entity.sonLaboratory = m.value
				this.refreshTable()
			},
			getTypeDicts() {
				this.$axios.post(this.$api.enums.selectEnumByCategory, {
					category: "紧急程度"
				}).then(res => {
					let data = res.data
					data.forEach(ele => {
						if (ele.value === '0') {
							ele.type = 'success'
						} else if (ele.value === '1') {
							ele.type = 'warning'
						} else if (ele.value === '2') {
							ele.type = 'danger'
						}
					})
					this.componentData.tagField.type.select = data
				})
			},
			getInsStateDicts() {
				this.$axios.post(this.$api.enums.selectEnumByCategory, {
					category: "检验任务状态"
				}).then(res => {
					let data = res.data
					this.insStateList = data
					data.forEach(ele => {
						//0:待检验 1:检验中 2:已检验 3:待复核 4:复核未通过 5:复核通过
						if (['2', '5'].includes(ele.value)) {
							ele.type = 'success'
						} else if (['1', '3'].includes(ele.value)) {
							ele.type = 'warning'
						} else if (['0', '4'].includes(ele.value)) {
							ele.type = 'danger'
						}
					})
					this.componentData.tagField.insState.select = data
				})
			},
			getLaboratoryDicts() {
				this.$axios.post(this.$api.enums.selectEnumByCategory, {
					category: "子实验室"
				}).then(res => {
					this.tabList = res.data.map(ele => {
						return {
							label: ele.label,
							value: ele.value
						}
					})
					if(this.tabList.length>0){
						this.componentData.entity.sonLaboratory = this.tabList[0].value
					}
					this.refreshTable()
				})
			},
			selectAllByOne(row) {
				this.activeFace = 2;
				this.currentId = parseInt(row.id)
			},
			playOrder(num) {
				this.activeFace = num
			},
      handleInspection(row){
        this.state = 1;
				this.orderId = row.id
      }
		}
	}
</script>
